/*************************************************************************
**Ansteuerung des ADC am Mediatek 2502									**
**																		**
**Erstellt 25.12.2015													**
**Autor: Martin Nowak													**
*************************************************************************/
#include "adc.h"

VM_DCL_HANDLE adc_handle = VM_DCL_HANDLE_INVALID;
VM_SIGNAL_ID adc_signalid = NULL;
VMINT32 adc_result = NULL;

void adc_callback(void* user_data, VM_DCL_EVENT event, VM_DCL_HANDLE device_handle)
{
    vm_dcl_callback_data_t *data;
    vm_dcl_adc_measure_done_confirm_t *result;

    if (user_data != NULL)
    {
    	data = (vm_dcl_callback_data_t *)user_data;
        result = (vm_dcl_adc_measure_done_confirm_t *)(data->local_parameters);

        if (result != NULL) adc_result = (result->value);
    }

    vm_signal_post(adc_signalid);
}

VMUINT32 adc_read(VMUINT32 pin)
{
	VM_DCL_STATUS adc_status;
	
	//PIN Mode auf ADC stellen
	adc_status = vm_dcl_config_pin_mode(pin,VM_DCL_PIN_MODE_ADC);

	adc_handle = vm_dcl_open(VM_DCL_ADC, 0);

	//Konfiguration des ADC Ports
	vm_dcl_adc_control_create_object_t adc_configuration;

	adc_configuration.owner_id = vm_dcl_get_owner_id();
	adc_configuration.channel = vm_dcl_pin_to_channel(pin);	//ADC Kanal der gewhlt werden soll
	adc_configuration.period = 1;							//Stellt die Lnge der Messperiode ein, in TICKS
	adc_configuration.evaluate_count = 1;					//Anzahl der Messungen die durchgefhrt werden soll
	adc_configuration.send_message_primitive = 1;

	adc_status = vm_dcl_control(adc_handle, VM_DCL_ADC_COMMAND_CREATE_OBJECT, (void *)&adc_configuration);

	//Registriere ADC Rckantwortfunktion
	adc_status = vm_dcl_register_callback(adc_handle, VM_DCL_ADC_GET_RESULT, (vm_dcl_callback)adc_callback, (void *)NULL);

	adc_signalid = vm_signal_create();

	//Startet ADC Auswertung
	vm_dcl_adc_control_send_start_t adc_conversion_start;

	adc_conversion_start.owner_id = vm_dcl_get_owner_id();

	adc_status = vm_dcl_control(adc_handle, VM_DCL_ADC_COMMAND_SEND_START, (void *)&adc_conversion_start);

	vm_signal_wait(adc_signalid);
	vm_signal_destroy(adc_signalid);

	//ADC Konversation stoppen
	vm_dcl_adc_control_send_stop_t adc_conversion_stop;

	adc_conversion_stop.owner_id = vm_dcl_get_owner_id();

	adc_status = vm_dcl_control(adc_handle, VM_DCL_ADC_COMMAND_SEND_STOP, (void *)&adc_conversion_stop);

	//ADC Schnittstelle wieder schliessen
	adc_status = vm_dcl_close(adc_handle);
	adc_handle = VM_DCL_HANDLE_INVALID;

	return adc_result;
}
